VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsNamedPipe"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
'Autor: Florian Rittmeier <florian@activevb.de>

Option Explicit

Private Declare Function CreateNamedPipe Lib "kernel32" Alias "CreateNamedPipeA" (ByVal lpName As String, ByVal dwOpenMode As Long, ByVal dwPipeMode As Long, ByVal nMaxInstances As Long, ByVal nOutBufferSize As Long, ByVal nInBufferSize As Long, ByVal nDefaultTimeOut As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Const PIPE_ACCESS_DUPLEX = &H3
'Private Const PIPE_ACCESS_INBOUND = &H1
'Private Const PIPE_ACCESS_OUTBOUND = &H2

Private Const INVALID_HANDLE_VALUE = -1 ' ist eigentlich anders definiert

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Private Const PIPE_TYPE_BYTE = &H0
'Private Const PIPE_TYPE_MESSAGE = &H4

Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function PeekNamedPipe Lib "kernel32" (ByVal hNamedPipe As Long, lpBuffer As Any, ByVal nBufferSize As Long, lpBytesRead As Long, lpTotalBytesAvail As Long, lpBytesLeftThisMessage As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const OPEN_EXISTING = 3

Private Declare Function WaitNamedPipe Lib "kernel32" Alias "WaitNamedPipeA" (ByVal lpNamedPipeName As String, ByVal nTimeOut As Long) As Long
'Private Const NMPWAIT_NOWAIT = &H1
Private Const NMPWAIT_USE_DEFAULT_WAIT = &H0
'Private Const NMPWAIT_WAIT_FOREVER = &HFFFF

Private Declare Function DisconnectNamedPipe Lib "kernel32" (ByVal hNamedPipe As Long) As Long
Public Event Error(ByVal Number As Long, ByVal Description As String)
Dim hPipe As Long
Dim server As Boolean
Public Property Get inUse() As Boolean
 inUse = (hPipe <> 0)
End Property
Public Property Get Handle() As Long
 Handle = hPipe
End Property
Public Function CreatePipe(ByVal Name As String) As Boolean
 If hPipe <> 0 Then
    RaiseEvent Error(4, "Verbindung zu einer Pipe besteht noch.")
    Exit Function
 End If
 
 Dim retval As Long
 Dim sec As SECURITY_ATTRIBUTES
 sec.nLength = Len(sec)
 
 retval = CreateNamedPipe("\\.\pipe\" & Name, PIPE_ACCESS_DUPLEX, PIPE_TYPE_BYTE, _
                    1, 2048, 2048, 100, sec)

 If retval <> INVALID_HANDLE_VALUE Then
    hPipe = retval
    server = True
    CreatePipe = True
 End If
End Function
Public Sub DisconnectFromPipe()
 If hPipe = 0 Then
    RaiseEvent Error(1, "Keine Pipe zum Schlieen vorhanden.")
    Exit Sub
 End If
 
 If server Then
    ' Alle Verbindungen schlieen
    Call DisconnectNamedPipe(hPipe)
    server = False
 End If
 Call CloseHandle(hPipe)
 hPipe = 0
End Sub
Public Function Write2Pipe(ByVal Text As String) As Boolean
 Dim retval As Long
 
 If hPipe = 0 Then
    RaiseEvent Error(2, "Keine Pipe zum Schreiben vorhanden.")
    Exit Function
 End If
 
 ' Diese Function ist fr Unicodestrings gedacht
 If LenB(Text) < 2 Or LenB(Text) Mod 2 = 1 Then
    RaiseEvent Error(3, "Text ist kein normaler Visual Basic String")
    Exit Function
 End If

 Dim lBytesWritten As Long
 Dim buffer() As Byte

 ' Platz fr den Text schaffen
 ReDim buffer((LenB(Text) / 2))

 ' Unicode nach ASCII (2 Byte -> 1 Byte Zeichen)
 buffer = StrConv(Text, vbFromUnicode) & vbNullChar
 
 retval = WriteFile(hPipe, buffer(0), UBound(buffer), lBytesWritten, 0&)
 
 ' Ein Fehler kann auch bedeuten, dass niemand zuhrt
 If retval <> 0 And lBytesWritten = UBound(buffer) - LBound(buffer) Then
    Write2Pipe = True
 End If
End Function

Public Function ReadFromPipe(ByRef Text As String) As Boolean
 Dim retval As Long
 Dim inbuf() As Byte
 Dim lread As Long, lavail As Long

 If hPipe = 0 Then
    RaiseEvent Error(5, "Keine Pipe zum Lesen vorhanden.")
    Exit Function
 End If
 
 ' Nachschaun wieviel Daten da sind.
 retval = PeekNamedPipe(hPipe, ByVal 0&, 0, 0, lavail, 0)

 If retval <> 0 And lavail > 0 Then
    ReDim inbuf(lavail - 1)
    
    ' Lesen der Daten
    retval = ReadFile(hPipe, inbuf(0), lavail, lread, 0)
    
    If retval = 0 Then
        ' Ein Fehler beim Lesen ist aufgetreten
        Exit Function
    End If
    
    Text = StrConv(inbuf, vbUnicode)
    ReadFromPipe = True
 End If
End Function
Public Property Get DataWaiting() As Boolean
 Dim retval As Long
 Dim lavail As Long

 If hPipe = 0 Then
    RaiseEvent Error(6, "Keine Pipe geffnet.")
    Exit Function
 End If

 retval = PeekNamedPipe(hPipe, ByVal 0&, 0, 0, lavail, 0)
 If retval <> 0 And lavail > 0 Then
    DataWaiting = True
 End If
End Property
Public Function Connect2ExistingPipe(ByVal Name As String, Optional ByVal ServerName As String = ".") As Boolean
 Dim retval As Long
 Dim pipename As String
 Dim sec As SECURITY_ATTRIBUTES
 sec.nLength = Len(sec)

 If hPipe <> 0 Then
    RaiseEvent Error(4, "Verbindung zu einer Pipe besteht noch.")
    Exit Function
 End If

 pipename = "\\" & ServerName & "\pipe\" & Name
 
 ' berprfen ob zur Pipe verbunden werden kann
 retval = WaitNamedPipe(pipename, NMPWAIT_USE_DEFAULT_WAIT)
 If retval = 0 Then
    RaiseEvent Error(6, "Pipe ist nicht frei.")
    Connect2ExistingPipe = False
    Exit Function
 End If

 ' Versuchen die Pipe zu ffnen
 retval = CreateFile(pipename, GENERIC_READ Or GENERIC_WRITE, 0, _
            sec, OPEN_EXISTING, 0, 0)
 If retval <> -1 Then
    hPipe = retval
    Connect2ExistingPipe = True
 End If
End Function

Private Sub Class_Terminate()
If Me.inUse Then Me.DisconnectFromPipe
End Sub
